%global _python_bytecompile_extra 0

%bcond_with  tests

Name:           pyproject-rpm-macros
# Keep the version at zero and increment only release
Version:        0
Release:        %mkrel 49
Summary:        RPM macros for PEP 517 Python packages
License:        MIT
Group:          Development/Python
URL:            https://src.fedoraproject.org/rpms/pyproject-rpm-macros
# Macro files
Source001:      pyproject.macros
# Implementation files
Source101:      pyproject_buildrequires.py
Source102:      pyproject_save_files.py
Source103:      pyproject_convert.py
Source104:      pyproject_preprocess_record.py
Source105:      pyproject_construct_toxenv.py
Source106:      pyproject_requirements_txt.py
# Tests
Source201:      test_pyproject_buildrequires.py
Source202:      test_pyproject_save_files.py
Source203:      test_pyproject_requirements_txt.py
# Test data
Source301:      pyproject_buildrequires_testcases.yaml
Source302:      pyproject_save_files_test_data.yaml
Source303:      test_RECORD
# Metadata
Source901:      README.md
Source902:      LICENSE

BuildArch:      noarch

Requires:      python3-rpm-macros
Requires:      python3-devel
Requires:      python3-pip >= 19
Requires:      python3-packaging
Requires:      python3-toml

%description
These macros allow projects that follow the Python packaging specifications
to be packaged as RPMs.

They are still provisional: we can make non-backwards-compatible changes to
the API.
Please subscribe to Fedora's python-devel list if you use the macros.

They work for:

* traditional Setuptools-based projects that use the setup.py file,
* newer Setuptools-based projects that have a setup.cfg file,
* general Python projects that use the PEP 517 pyproject.toml file
  (which allows using any build system, such as setuptools, flit or poetry).

These macros replace %%py3_build and %%py3_install,
which only work with setup.py.


%prep
# Not strictly necessary but allows working on file names instead
# of source numbers in install section
%setup -c -T
cp -p %{sources} .

%build
# nothing to do, sources are not buildable

%install
mkdir -p %{buildroot}/%{_sysconfdir}/rpm/macros.d/
mkdir -p %{buildroot}%{_rpmconfigdir}/mandriva
install -m 644 pyproject.macros %{buildroot}/%{_sysconfdir}/rpm/macros.d/
install -m 644 pyproject_buildrequires.py %{buildroot}%{_rpmconfigdir}/mandriva/
install -m 644 pyproject_convert.py %{buildroot}%{_rpmconfigdir}/mandriva/
install -m 644 pyproject_save_files.py  %{buildroot}%{_rpmconfigdir}/mandriva/
install -m 644 pyproject_preprocess_record.py %{buildroot}%{_rpmconfigdir}/mandriva/
install -m 644 pyproject_construct_toxenv.py %{buildroot}%{_rpmconfigdir}/mandriva/
install -m 644 pyproject_requirements_txt.py %{buildroot}%{_rpmconfigdir}/mandriva/


%files
%{_sysconfdir}/rpm/macros.d/pyproject.macros
%{_rpmconfigdir}/mandriva/pyproject_buildrequires.py
%{_rpmconfigdir}/mandriva/pyproject_convert.py
%{_rpmconfigdir}/mandriva/pyproject_save_files.py
%{_rpmconfigdir}/mandriva/pyproject_preprocess_record.py
%{_rpmconfigdir}/mandriva/pyproject_construct_toxenv.py
%{_rpmconfigdir}/mandriva/pyproject_requirements_txt.py

%doc LICENSE README.md

%changelog
* Sun Aug 14 2022 TerryN <terryn94 at gmail.com> 0-49pclos2022
- don't generate license macro (our rpm doesn't support it)
- remove pyproject_record file before processing

* Wed Aug 10 2022 TerryN <terryn94 at gmail.com> 0-48pclos2022
- fix pyproject_save_files for pclos

* Thu Mar 03 2022 TerryN <terryn94 at gmail.com> 0-47pclos2022
- imported package for python 3.10
